{$I DEFINES.INC}
{

Copyright 2007 Jakob Dangarden

 This file is part of Usurper.

    Usurper is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Usurper is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Usurper; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
}

unit EDHELP;

interface

const

  hcAbout                = 4;
  hcAdios                = 2;
  hcArmorfile            = 17;
  hcAutoEquip            = 850;
  hcChildEditor          = 73;
  hcConfig               = 3;
  hcConfigGoto           = 481;
  hcConfigNew            = 480;
  hcConfigSearch         = 482;
  hcConfigToggle         = 483;
  hcDGBaseArmor          = 107;
  hcDGBaseAttack         = 108;
  hcDGcost               = 101;
  hcDGcreate             = 105;
  hcDGDesc               = 104;
  hcDGHitpoints          = 106;
  hcDGmany               = 102;
  hcDGmany2              = 103;
  hcDGName               = 100;
  hcDGSearch             = 109;
  hcDocFiles             = 23;
  hcDoorGuardEditor      = 8;
  hcDoorguardfile        = 14;
  hcDrinkComment         = 604;
  hcDrinkCreator         = 603;
  hcDrinkDate            = 602;
  hcDrinkDeleted         = 610;
  hcDrinkDeleted2        = 611;
  hcDrinkEditor          = 600;
  hcDrinkLastHad         = 606;
  hcDrinkLastOrdered     = 607;
  hcDrinkName            = 601;
  hcDrinkOrdered         = 605;
  hcDrinkSearch          = 612;
  hcDrinkSecret          = 608;
  hcDrinkSecret2         = 609;
  hcDrinkViewIng         = 613;
  hcEquipAbody           = 815;
  hcEquipArms            = 804;
  hcEquipBody            = 803;
  hcEquipDrink           = 820;
  hcEquipFace            = 812;
  hcEquipFeet            = 808;
  hcEquipFinger1         = 805;
  hcEquipFinger2         = 806;
  hcEquipFingers         = 817;
  hcEquipFood            = 819;
  hcEquipHands           = 814;
  hcEquipHead            = 802;
  hcEquipLeftHand        = 800;
  hcEquipLegs            = 807;
  hcEquipNeck1           = 810;
  hcEquipNeck2           = 811;
  hcEquipNecks           = 818;
  hcEquipRightHand       = 801;
  hcEquipShield          = 813;
  hcEquipWaist           = 809;
  hcEquipWeapons         = 816;
  hcFutureDoc            = 55;
  hcGenCancel            = 4001;
  hcGenFileName          = 4005;
  hcGenGoto              = 4007;
  hcGenNext              = 4003;
  hcGenNo                = 4010;
  hcGenNumeric           = 4004;
  hcGenOk                = 4000;
  hcGenPrevious          = 4002;
  hcGenSearch            = 4008;
  hcGenString            = 4006;
  hcGenYes               = 4009;
  hcGodEditor            = 72;
  hcInventory            = 900;
  hcInventoryItem        = 901;
  hcInventoryRemove      = 902;
  hcItemAgility          = 412;
  hcItemArmor            = 403;
  hcItemAtlevel1         = 408;
  hcItemAtLevel2         = 409;
  hcItemAttack           = 402;
  hcItemCharisma         = 413;
  hcItemCreate           = 431;
  hcItemCure1            = 441;
  hcItemCure2            = 442;
  hcItemCure3            = 443;
  hcItemCure4            = 444;
  hcItemCure5            = 445;
  hcItemCure6            = 446;
  hcItemCure7            = 447;
  hcItemCursed1          = 425;
  hcItemCursed2          = 426;
  hcItemDefence          = 418;
  hcItemDesc1            = 404;
  hcItemDesc2            = 405;
  hcItemDexterity        = 414;
  hcItemEditor           = 9;
  hcItemEvil1            = 423;
  hcItemEvil2            = 424;
  hcItemExport           = 435;
  hcItemfile             = 15;
  hcItemFound            = 407;
  hcItemGood1            = 421;
  hcItemGood2            = 422;
  hcItemHps              = 410;
  hcItemImport           = 434;
  hcItemInfo             = 437;
  hcItemMana             = 416;
  hcItemName             = 400;
  hcItemOptions          = 433;
  hcItemRemove           = 436;
  hcItemRestrict         = 427;
  hcItemSearch           = 430;
  hcItemStamina          = 411;
  hcItemStore            = 406;
  hcItemStrength         = 417;
  hcItemStrNeed          = 419;
  hcItemType             = 432;
  hcItemValue            = 401;
  hcItemWisdom           = 415;
  hcLevEdExpNeed         = 22;
  hcLevelEditor          = 71;
  hcLevelfile            = 13;
  hcMainHelp             = 1;
  hcMeditArmor           = 312;
  hcMeditDefence         = 308;
  hcMeditEvil            = 310;
  hcMeditGlobal          = 317;
  hcMeditGoto            = 301;
  hcMeditGrabArm2        = 316;
  hcMeditGrabArmor       = 315;
  hcMeditGrabWeap2       = 314;
  hcMeditGrabWeapon      = 313;
  hcMeditGrmvSpells      = 318;
  hcMeditHitpoints       = 303;
  hcMeditIQ              = 309;
  hcMeditMagicLev        = 306;
  hcMeditMagicRes        = 305;
  hcMeditMonster         = 302;
  hcMeditPhrase          = 304;
  hcMeditSearch          = 300;
  hcMeditSpells1         = 350;
  hcMeditSpells2         = 351;
  hcMeditSpells3         = 352;
  hcMeditSpells4         = 353;
  hcMeditSpells5         = 354;
  hcMeditSpells6         = 355;
  hcMeditStrength        = 307;
  hcMeditWeapon          = 311;
  hcMoatBaseArmor        = 634;
  hcMoatBaseAttack       = 635;
  hcMoatCost             = 632;
  hcMoatCreate           = 640;
  hcMoatDeleted          = 637;
  hcMoatDeleted2         = 638;
  hcMoatDesc             = 636;
  hcMoatEditor           = 630;
  hcmoatfile             = 21;
  hcMoatHps              = 633;
  hcMoatName             = 631;
  hcMoatSearch           = 639;
  hcMonsterEditor        = 10;
  hcMonsterfile          = 16;
  hcMoreEditors          = 24;
  hcNpcfile              = 19;
  hcODosShell            = 62;
  hcOptions              = 60;
  hcOptionsToggle        = 61;
  hcPeditAge             = 536;
  hcPeditAgility         = 546;
  hcPeditAlias           = 507;
  hcPeditAllowed1        = 530;
  hcPeditAllowed2        = 531;
  hcPeditBank            = 509;
  hcPeditBattleCry       = 651;
  hcPeditBrawls          = 521;
  hcPeditCharisma        = 547;
  hcPeditChivalry        = 537;
  hcPeditClass1          = 581;
  hcPeditClass10         = 590;
  hcPeditClass11         = 591;
  hcPeditClass2          = 582;
  hcPeditClass3          = 583;
  hcPeditClass4          = 584;
  hcPeditClass5          = 585;
  hcPeditClass6          = 586;
  hcPeditClass7          = 587;
  hcPeditClass8          = 588;
  hcPeditClass9          = 589;
  hcPeditControl1        = 524;
  hcPeditControl2        = 525;
  hcPeditCreate          = 505;
  hcPeditDarkness        = 538;
  hcPeditDefence         = 540;
  hcPeditDelete          = 500;
  hcPeditDesc            = 270;
  hcPeditDexterity       = 548;
  hcPeditDis1            = 272;
  hcPeditDis2            = 273;
  hcPeditDis3            = 274;
  hcPeditDis4            = 275;
  hcPeditDis5            = 276;
  hcPeditDngFights       = 512;
  hcPeditDrugAddict      = 519;
  hcPeditEquip           = 502;
  hcPeditEvilDeeds       = 542;
  hcPeditExperience      = 510;
  hcPeditGender1         = 526;
  hcPeditGender2         = 527;
  hcPeditGoodDeeds       = 541;
  hcPeditHealings        = 511;
  hcPeditHps             = 534;
  hcPeditKing1           = 528;
  hcPeditKing2           = 529;
  hcPeditLevel           = 533;
  hcPeditMana            = 543;
  hcPeditMaxHps          = 535;
  hcPeditMaxMana         = 544;
  hcPeditMaxTime         = 277;
  hcPeditMDefeats        = 296;
  hcPeditMental          = 518;
  hcPeditMKills          = 295;
  hcPeditMoney           = 508;
  hcPeditMore            = 503;
  hcPeditMove1           = 281;
  hcPeditMove10          = 290;
  hcPeditMove11          = 291;
  hcPeditMove12          = 292;
  hcPeditMove13          = 293;
  hcPeditMove14          = 294;
  hcPeditMove2           = 282;
  hcPeditMove3           = 283;
  hcPeditMove4           = 284;
  hcPeditMove5           = 285;
  hcPeditMove6           = 286;
  hcPeditMove7           = 287;
  hcPeditMove8           = 288;
  hcPeditMove9           = 289;
  hcPeditName            = 506;
  hcPeditNeverDel        = 271;
  hcPeditPassWord        = 516;
  hcPeditPDefeats        = 298;
  hcPeditPhrase1         = 652;
  hcPeditPhrase2         = 653;
  hcPeditPhrase3         = 654;
  hcPeditPhrase4         = 655;
  hcPeditPhrase5         = 656;
  hcPeditPhrase6         = 657;
  hcPeditPhrases         = 650;
  hcPeditPKills          = 297;
  hcPeditPlyFights       = 513;
  hcPeditRace1           = 561;
  hcPeditRace10          = 570;
  hcPeditRace2           = 562;
  hcPeditRace3           = 563;
  hcPeditRace4           = 564;
  hcPeditRace5           = 565;
  hcPeditRace6           = 566;
  hcPeditRace7           = 567;
  hcPeditRace8           = 568;
  hcPeditRace9           = 569;
  hcPeditRevive          = 501;
  hcPeditSearch          = 504;
  hcPeditSpells1         = 206;
  hcPeditSpells10        = 215;
  hcPeditSpells11        = 216;
  hcPeditSpells12        = 217;
  hcPeditSpells2         = 207;
  hcPeditSpells20        = 230;
  hcPeditSpells21        = 231;
  hcPeditSpells22        = 232;
  hcPeditSpells23        = 233;
  hcPeditSpells24        = 234;
  hcPeditSpells25        = 235;
  hcPeditSpells26        = 236;
  hcPeditSpells27        = 237;
  hcPeditSpells28        = 238;
  hcPeditSpells29        = 239;
  hcPeditSpells3         = 208;
  hcPeditSpells30        = 240;
  hcPeditSpells31        = 241;
  hcPeditSpells35        = 250;
  hcPeditSpells36        = 251;
  hcPeditSpells37        = 252;
  hcPeditSpells38        = 253;
  hcPeditSpells39        = 254;
  hcPeditSpells4         = 209;
  hcPeditSpells40        = 255;
  hcPeditSpells41        = 256;
  hcPeditSpells42        = 257;
  hcPeditSpells43        = 258;
  hcPeditSpells44        = 259;
  hcPeditSpells45        = 260;
  hcPeditSpells46        = 261;
  hcPeditSpells5         = 210;
  hcPeditSpells6         = 211;
  hcPeditSpells7         = 212;
  hcPeditSpells8         = 213;
  hcPeditSpells9         = 214;
  hcPeditStamina         = 545;
  hcPeditStrength        = 539;
  hcPeditTeam            = 515;
  hcPeditTeamFights      = 514;
  hcPeditThefts          = 520;
  hcPeditTrainings       = 522;
  hcPeditWisdom          = 549;
  hcPlayerEditor         = 5;
  hcReadMe               = 54;
  hcRemoveAll            = 851;
  hcResetData            = 12;
  hcResetGame            = 11;
  hcSupportDoc           = 56;
  hcSysopDoc             = 52;
  hcteamnamefile         = 20;
  hcUsurperDoc           = 53;
  hcViewFile             = 50;
  hcWeaponfile           = 18;
  hcWhatsNew             = 51;

implementation

end.
